/***************************************************************************
 *   Copyright (C) 2008 by Tamino Dauth                                    *
 *   tamino@cdauth.eu                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <QtGui>

#include "progressdialog.h"

namespace hpp
{

bool ProgressDialog::canceled() const
{
	return m_canceled;
}

ProgressDialog::ProgressDialog(MainWindow *parent) : QDialog(parent), maxValue(0), m_canceled(false)
{
	setupUi(this);

	connect(this, SIGNAL(rejected()), this, SLOT(finish()));

	hide();
}

void ProgressDialog::run(MainWindow::ValueType maxValue)
{
	m_canceled = false;
	time.start();
	this->maxValue = maxValue;
	retranslateUi(this);
	show();
}

void ProgressDialog::changeValue(MainWindow::ValueType value)
{
	progressBar->setValue(value * 100 / maxValue);
	qApp->processEvents();
}

void ProgressDialog::finish()
{
	if (m_canceled)
		return;

	timeLabel->setText(tr("Vergangene Zeit:<br>%1 Millisekunden").arg(time.elapsed()));
	m_canceled = true;
	qApp->processEvents();
}

}
